diff --git a/src/lib/tree.c b/src/lib/tree.c
index 9e55e72542..1f12399c52 100644
--- a/src/lib/tree.c
+++ b/src/lib/tree.c
@@ -158,33 +158,41 @@ ncplane* nctree_plane(nctree* n){
 // extend it out to the maximal topright.
 static nctree_int_item*
 nctree_prev_internal(nctree* n, unsigned* newpath){
+for(int i = 0 ; i < 100 ; ++i){
+if(newpath[i] == UINT_MAX){ fprintf(stderr, " <---- prevpath\n"); break; }
+fprintf(stderr, "%u ", newpath[i]);
+}
   nctree_int_item* nii = &n->items;
   nctree_int_item* wedge = NULL; // tracks the rightmost non-zero path
   int idx = 0;
-  while((newpath[idx] = newpath[idx]) != UINT_MAX){
+  while(newpath[idx] != UINT_MAX){
     nii = &nii->subs[newpath[idx]];
+//fprintf(stderr, "FORVART %s subs: %u via %u\n", (const char*)nii->curry, nii->subcount, newpath[idx]);
     if(idx == 0){
       wedge = &n->items;
     }else{// if(idx > 1){
       wedge = &wedge->subs[newpath[idx - 1]];
+//fprintf(stderr, "WEDGE %s subs: %u via %u\n", (const char*)wedge->curry, wedge->subcount, newpath[idx - 1]);
     }
     ++idx;
   }
-  if(newpath[idx - 1]){
-    --newpath[idx - 1];
-    nii = &wedge->subs[newpath[idx - 1]];
+  --idx;
+  if(newpath[idx]){
+    --newpath[idx];
+    nii = &wedge->subs[newpath[idx]];
     while(nii->subcount){
-      newpath[idx - 1] = nii->subcount - 1;
-      nii = &nii->subs[newpath[idx - 1]];
-      ++idx;
+      newpath[idx] = nii->subcount - 1;
+      nii = &nii->subs[newpath[idx]];
     }
+fprintf(stderr, "OUT 1 %d\n", idx);
     newpath[idx] = UINT_MAX;
     return nii;
   }
   if(wedge == &n->items){
     return nii; // no change
   }
-  newpath[idx - 1] = UINT_MAX;
+fprintf(stderr, "OUT 2 %d\n", idx + 1);
+  newpath[idx] = UINT_MAX;
   return wedge;
 }
 
@@ -203,7 +211,7 @@ nctree_next_internal(nctree* n, unsigned* newpath){
   nctree_int_item* wedge = NULL;  // tracks the rightmost with room in subs
   int idx = 0;
   int wedidx = 0;
-  while((newpath[idx] = newpath[idx]) != UINT_MAX){
+  while(newpath[idx] != UINT_MAX){
     if(newpath[idx] < nii->subcount - 1){
       wedge = nii;
       wedidx = idx;
@@ -227,6 +235,12 @@ nctree_next_internal(nctree* n, unsigned* newpath){
 void* nctree_next(nctree* n){
   // FIXME update n->activerow, redraw
   n->curitem = nctree_next_internal(n, n->currentpath);
+fprintf(stderr, "NEXT------------------------->\n");
+for(int i = 0 ; i < 100 ; ++i){
+if(n->currentpath[i] == UINT_MAX){ fprintf(stderr, " <---- nextpath\n"); break; }
+fprintf(stderr, "%u ", n->currentpath[i]);
+}
+fprintf(stderr, "NEXT DONE\n");
   return n->curitem->curry;
 }
 
@@ -306,6 +320,7 @@ nctree_inner_redraw(nctree* n, unsigned* tmppath){
   if(draw_tree_item(n, nii, tmppath, &frontiert, &frontierb)){
     return -1;
   }
+fprintf(stderr, "FULCRUM %s\n", (const char*)nii->curry);
   nctree_int_item* tmpnii;
   // draw items above the current one FIXME
   while(frontiert >= 0){
@@ -316,6 +331,7 @@ nctree_inner_redraw(nctree* n, unsigned* tmppath){
     if(draw_tree_item(n, nii, tmppath, &frontiert, &frontierb)){
       return -1;
     }
+fprintf(stderr, "DRAWING %s\n", (const char*)nii->curry);
   }
   // FIXME destroy any drawn ones before us
   // move items up if there is a gap at the top FIXME
diff --git a/src/poc/tree.c b/src/poc/tree.c
index 100921df3b..d71666063c 100644
--- a/src/poc/tree.c
+++ b/src/poc/tree.c
@@ -365,6 +365,7 @@ callback(struct ncplane* ncp, void* curry, int dizzy){
       return -1;
     }
   }
+  ncplane_cursor_move_yx(ncp, 0, 0);
   ncplane_putstr(ncp, curry);
   // FIXME
   (void)dizzy;
diff --git a/src/tests/tree.cpp b/src/tests/tree.cpp
index 4b3b9ddc7e..ce492536d5 100644
--- a/src/tests/tree.cpp
+++ b/src/tests/tree.cpp
@@ -167,6 +167,7 @@ TEST_CASE("Tree") {
 
     CHECK(items[0].curry == nctree_prev(tree));
     CHECK(items[0].curry == nctree_focused(tree));
+
     nctree_destroy(tree);
   }
 
